CON
  _CLKMODE = XTAL1 + PLL16X        ' 80 Mhz clock
  _XINFREQ = 5_000_000

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq               ' system freq as a constant
  MS_001   = CLK_FREQ / 1_000                                   ' ticks in 1ms
  US_001   = CLK_FREQ / 1_000_000                               ' ticks in 1us

'enumerated notes
  #0, C6, D6, E6, F6, G6, A6, B6, C7, D7, E7, F7, G7, A7, B7, C8, R
      
VAR
  byte cog
  byte pinA
  byte pinB 
  long Stack[20]  

PUB Start(_pinA,_pinB, note, beeps, duration) : result
{{
   _pinA, _pinB - propeller pins connected to piezo speaker
}}
    pinA := _pinA
    pinB := _pinB
    Stop
'   byte[addrMainCode] := NoNewCode
    cog := cognew(alarm(note, beeps, duration), @Stack) + 1
    result := cog


PUB Stop
{{
   stop cog if in use
}}

    if cog
      cogstop(cog~ -1)

PRI alarm(note, beeps, duration) | t, incr
  ctra[30..26] := %00101              'NCO differential mode
  ctra[5..0] := pinA                  'APIN  (primary pin)                
  ctra[14..9] := pinB                 'BPIN  (secondary pin)
  frqa := frequencies[notes[note]]
  dira[pinA..pinB]~

  t :=  cnt
  incr := MS_001 * duration
  repeat beeps
    !dira[pinA..pinB]
    waitcnt(t += incr)
  ctra := 0   

DAT
notes         byte      C6,D6,E6,F6,G6,A6,B6,C7,D7,E7,F7,G7,A7,B7,C8, R
'tempo        byte       4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4
       
frequencies   long       56_184,  63_066,  70_786,  74_995,  84_181             'C6 - G6
              long       94_489, 105_629, 112_528, 126_127, 141_572             'A6 - E7
              long      149_990, 168_362, 188_978, 212_123, 224_734, 0          'F7 - C8, R